"use strict"
var fs = require("fs")
var path = require("path")
var nrrd = require("nrrd-js")
var ndarray = require("ndarray")
var zeros = require("zeros")
var decompose = require("tensor-decomposition")

var tensorFile = nrrd.parse(fs.readFileSync(path.join("out","score.nrrd")))
var tensorField = ndarray(tensorFile.data, tensorFile.sizes.slice().reverse())

var shape = Array.apply([], tensorField.shape)

var vectors = zeros(shape.slice(0,-1).concat(6)), decRes, r, c, i, pos, tensor
var numwritten = 0
for(r=0; r<shape[0]; r++) {
//for(r=50; r<90; r++) {
  for(c=0; c<shape[1]; c++) {
  //for(c=170; c<220; c++) {
    tensor = [tensorField.get(r,c,0),tensorField.get(r,c,1),tensorField.get(r,c,2),tensorField.get(r,c,3),tensorField.get(r,c,4)]
    if (tensor[0]*tensor[0]+4*tensor[1]*tensor[1]+6*tensor[2]*tensor[2]+4*tensor[3]*tensor[3]+tensor[4]*tensor[4]<1e-3) continue
    decRes = decompose(tensor)
    pos = 0
    for(i=0; i<decRes.lambda.length; i++) {
      if (decRes.grade[i] === 1) {
        vectors.set(r,c,2*pos+0, -decRes.lambda[i]*decRes.v[i][1]) // Rotate vectors by 90 degrees to ensure that they point /along/ the curve rather than perpendicular to it.
        vectors.set(r,c,2*pos+1,  decRes.lambda[i]*decRes.v[i][0])
        pos++
        numwritten++
        if (pos === 3) break
      }
    }
  }
  //if (numwritten >= 10000) break
}

fs.writeFileSync(path.join("out","vectors.nrrd"), new Buffer(new Uint8Array(nrrd.serialize({data: vectors.data, sizes: vectors.shape.slice().reverse()}))))
