"use strict"
var fs = require("fs")
var path = require("path")
var nrrd = require("nrrd-js")
var ndarray = require("ndarray")

var vectorsParsed = nrrd.parse(fs.readFileSync(path.join("out","vectors.nrrd")))
var vectors = ndarray(vectorsParsed.data, vectorsParsed.sizes.slice().reverse())
var shape = vectors.shape

var svgLines = ['<?xml version="1.0" standalone="no"?>',
                '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" ',
                '  "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">',
                '<svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="' + (5*shape[1]) + 'px" height="' + (5*shape[0]) + 'px">',
                '<g transform="scale(5)">']

var r, c, pos, vx, vy, temp
for(r=0; r<shape[0]; r++) {
  for(c=0; c<shape[1]; c++) {
    for(pos=0; 2*pos<shape[2]; pos++) {
      vx = vectors.get(r,c,2*pos+0)/510
      vy = vectors.get(r,c,2*pos+1)/510
      if (vx*vx+vy*vy < 1e-3) continue
      svgLines.push('<path d="M ' + (c+0.5-vx) + ',' + (r+0.5-vy) + ' ' +
                                    (c+0.5+vx) + "," + (r+0.5+vy) + '" stroke="black" stroke-width="0.1" />')
    }
  }
}

svgLines.push('</g>')
svgLines.push('</svg>')

fs.writeFileSync(path.join("out","vectors.svg"), svgLines.join('\n'))
