var test = require('tape');
var pathOpening = require('./index.js');

test("node weights", function (t) {
    var v,
        adjacencyList = [[2], [2, 3], [4], [4], []],
        nodeWeights = [0, 1, 2, 4, 8],
        pot,
        maxWeightBeforeRef = [0, 0, 1, 1, 1+4],
        parentRef = [-1, -1, 1, 1, 3];

    pot = pathOpening(adjacencyList, nodeWeights);
    
    t.equal(pot.maxWeightBefore.length, maxWeightBeforeRef.length);
    
    for(v=0; v<pot.maxWeightBefore.length; v++) {
        t.equal(pot.maxWeightBefore[v], maxWeightBeforeRef[v]);
    }
    
    t.equal(pot.parent.length, parentRef.length);
    
    for(v=0; v<pot.parent.length; v++) {
        t.equal(pot.parent[v], parentRef[v]);
    }
    
    t.end();
});

test("node and edge weights", function (t) {
    var v,
        adjacencyList = [[2], [2, 3], [4], [4], []],
        nodeWeights = [0, 1, 2, 4, 8],
        edgeWeights = [[1], [16, 32], [128], [64], []],
        pot,
        maxWeightBeforeRef = [0, 0, 1+16, 1+32, 1+16+2+128],
        parentRef = [-1, -1, 1, 1, 2];

    pot = pathOpening(adjacencyList, nodeWeights, edgeWeights);
    
    t.equal(pot.maxWeightBefore.length, maxWeightBeforeRef.length);
    
    for(v=0; v<pot.maxWeightBefore.length; v++) {
        t.equal(pot.maxWeightBefore[v], maxWeightBeforeRef[v]);
    }
    
    t.equal(pot.parent.length, parentRef.length);
    
    for(v=0; v<pot.parent.length; v++) {
        t.equal(pot.parent[v], parentRef[v]);
    }
    
    t.end();
});

