"use strict"
var opts = require('yargs').usage("Usage: node reconstruct JSON_GRAPH_IN PNG_OUT").demand(2).argv
var fs = require("fs")
var ndarray = require("ndarray")
var ops = require("ndarray-ops")
var savePixels = require("save-pixels")

var dataConn = JSON.parse(fs.readFileSync(opts._[0], {encoding: "utf-8"}))
var data = dataConn.data
var sizes = dataConn.sizes
var img = ndarray(new Float32Array(sizes[0]*sizes[1]*4), sizes.slice().reverse().concat(4))

for(var y=0; y<sizes[1]; y++) {
  for(var x=0; x<sizes[0]; x++) {
    img.set(y,x,3, 255)
  }
}

var x, y, vx, vy, norm, newval
for(var i=0; i<data.length; i++) {
  x = data[i][0]
  y = data[i][1]
  vx = data[i][2]
  vy = data[i][3]
  norm = Math.sqrt(vx*vx+vy*vy)
  newval = img.get(y,x,0) + norm*255/2 // The coefficient 255 stems from the coefficient used in buildGraph.js, the division by 2 stems from the fact that every rank-one component is represented as /two/ (opposite) vectors.
  img.set(y,x,0, newval)
  img.set(y,x,1, newval)
  img.set(y,x,2, newval)
}

savePixels(img, "png").pipe(fs.createWriteStream(opts._[1]))

console.log("Range: " + ops.inf(img) + " to " + ops.sup(img))

