"use strict"
var fs = require("fs")
var path = require("path")
var getPixels = require("get-pixels")
var savePixels = require("save-pixels")
var ops = require("ndarray-ops")
var nrrd = require("nrrd-js")
var orientationScore = require("orientation-scores")

getPixels(path.join("in","wigglesNoisy-inv.png"), function(err, pixels) {
  var orScore = orientationScore(pixels.pick(null,null,0), 4) // Create a fourth order tensorial orientation score

  fs.writeFileSync(path.join("out", "score.nrrd"), new Buffer(new Uint8Array(nrrd.serialize({data: orScore.data, sizes: orScore.shape.slice().reverse()}))))
})

